// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, QedaPattern, QedaSymbol,
    slice = [].slice;

  QedaSymbol = require('./qeda-symbol');

  QedaPattern = require('./qeda-pattern');

  QedaElement = (function() {
    function QedaElement(library, definition) {
      var h, i, j, key, l, last, len, len1, m, o, p, part, pinName, pinNumber, pinNumbers, ref, ref1, ref2, ref3, ref4, symbol, value;
      this.library = library;
      this.mergeObjects(this, definition);
      this.refDes = 'REF';
      this.symbols = [];
      this.patterns = [];
      this.pins = [];
      this.groups = [];
      this._letters = ['', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'R', 'T', 'U', 'V', 'W', 'Y'];
      last = this._letters.length - 1;
      for (i = l = 1, ref = last; 1 <= ref ? l <= ref : l >= ref; i = 1 <= ref ? ++l : --l) {
        for (j = m = ref1 = i, ref2 = last; ref1 <= ref2 ? m <= ref2 : m >= ref2; j = ref1 <= ref2 ? ++m : --m) {
          this._letters.push(this._letters[i] + this._letters[j]);
        }
      }
      for (pinName in this.pinout) {
        pinNumbers = this._pinNumbers(this.pinout[pinName]);
        this.groups[pinName] = pinNumbers;
        for (o = 0, len = pinNumbers.length; o < len; o++) {
          pinNumber = pinNumbers[o];
          if (this.pins[pinNumber] == null) {
            this.pins[pinNumber] = this._pinObj(pinNumber, pinName);
          } else {
            this.pins[pinNumber].name += ' / ' + pinName;
          }
        }
      }
      ref3 = this.group;
      for (key in ref3) {
        value = ref3[key];
        this.groups[key] = this._concatenateGroups(value);
      }
      i = 1;
      while (this.schematic['part' + i] != null) {
        symbol = new QedaSymbol(this, this.schematic['part' + i]);
        this.symbols.push(new QedaSymbol(this, this.schematic['part' + i]));
        ++i;
      }
      if (this.symbols.length === 0) {
        part = [];
        if (this.group != null) {
          for (key in this.group) {
            part.push(key);
          }
        } else {
          for (key in this.pinout) {
            part.push(key);
          }
        }
        this.symbols.push(new QedaSymbol(this, part));
      }
      if (!Array.isArray(this.housing)) {
        this.housing = [this.housing];
      }
      ref4 = this.housing;
      for (p = 0, len1 = ref4.length; p < len1; p++) {
        h = ref4[p];
        if (typeof h === 'object') {
          this.addPattern(h);
        } else if (typeof h === 'string') {
          if (this[h] != null) {
            this.addPattern(this[h]);
          }
        }
      }
    }

    QedaElement.prototype.addPattern = function(housing) {
      if (housing.pattern == null) {
        return;
      }
      return this.patterns.push(new QedaPattern(this, housing));
    };

    QedaElement.prototype.calculate = function(gridSize) {
      var cap, def, handler, l, len, len1, len2, len3, len4, m, o, outline, p, pattern, q, ref, ref1, ref2, ref3, ref4, ref5, ref6, symbol;
      if (this._calculated == null) {
        this._calculated = false;
      }
      if (this._calculated) {
        return;
      }
      handler = require("./element/" + this.library.elementStyle);
      handler(this);
      ref = this.symbols;
      for (l = 0, len = ref.length; l < len; l++) {
        symbol = ref[l];
        if (((ref1 = this.schematic) != null ? ref1.symbol : void 0) != null) {
          ref2 = this.library.symbolDefs;
          for (m = 0, len1 = ref2.length; m < len1; m++) {
            def = ref2[m];
            cap = def.regexp.exec(this.schematic.symbol);
            if (cap) {
              handler = require("./symbol/" + this.library.symbolStyle + "/" + def.handler);
              handler.apply(null, [symbol].concat(slice.call(cap.slice(1))));
            }
          }
        }
        symbol.calculate(gridSize);
      }
      ref3 = this.patterns;
      for (o = 0, len2 = ref3.length; o < len2; o++) {
        pattern = ref3[o];
        if (((ref4 = pattern.housing) != null ? ref4.outline : void 0) != null) {
          outline = pattern.housing.outline;
          ref5 = this.library.outlineDefs;
          for (p = 0, len3 = ref5.length; p < len3; p++) {
            def = ref5[p];
            cap = def.regexp.exec(outline);
            if (cap) {
              handler = require("./outline/" + def.handler);
              handler.apply(null, [pattern.housing].concat(slice.call(cap.slice(1))));
            }
          }
        }
        this._convertDimensions(pattern.housing);
        ref6 = this.library.patternDefs;
        for (q = 0, len4 = ref6.length; q < len4; q++) {
          def = ref6[q];
          cap = def.regexp.exec(pattern.name);
          if (cap) {
            handler = require("./pattern/" + this.library.patternStyle + "/" + def.handler);
            handler.apply(null, [pattern].concat(slice.call(cap.slice(1))));
          }
        }
      }
      return this._calculated = true;
    };

    QedaElement.prototype.isFloat = function(n) {
      return Number(n) && (n % 1 !== 0);
    };

    QedaElement.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaElement.prototype._concatenateGroups = function(groups) {
      var group, l, len, result;
      result = [];
      if (!Array.isArray(groups)) {
        groups = [groups];
      }
      for (l = 0, len = groups.length; l < len; l++) {
        group = groups[l];
        result = result.concat(this.groups[group]);
      }
      return result;
    };

    QedaElement.prototype._convertDimensions = function(housing) {
      var key, max, min, nom, results, tol, value;
      results = [];
      for (key in housing) {
        value = housing[key];
        if (Array.isArray(value) && value.length > 0) {
          min = value[0];
          max = value.length > 1 ? value[1] : min;
          nom = (max + min) / 2;
          tol = max - min;
          results.push(housing[key] = {
            min: min,
            max: max,
            nom: nom,
            tol: tol
          });
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaElement.prototype._pinNumbers = function(inputs) {
      var cap, i, input, j, l, len, len1, m, numbers, o, p, ref, ref1, ref2, ref3, sub, subs;
      numbers = [];
      if (!Array.isArray(inputs)) {
        inputs = [inputs];
      }
      for (l = 0, len = inputs.length; l < len; l++) {
        input = inputs[l];
        if (typeof input === 'number') {
          numbers.push(input.toString());
        } else if (typeof input === 'string') {
          input = input.replace(/\s+/g, '');
          subs = input.split(',');
          for (m = 0, len1 = subs.length; m < len1; m++) {
            sub = subs[m];
            cap = /([A-Z]*)(\d+)\.{2,3}([A-Z]*)(\d+)/.exec(sub);
            if (!cap) {
              numbers.push(sub);
            } else {
              for (i = o = ref = this._letters.indexOf(cap[1]), ref1 = this._letters.indexOf(cap[3]); ref <= ref1 ? o <= ref1 : o >= ref1; i = ref <= ref1 ? ++o : --o) {
                for (j = p = ref2 = cap[2], ref3 = cap[4]; ref2 <= ref3 ? p <= ref3 : p >= ref3; j = ref2 <= ref3 ? ++p : --p) {
                  numbers.push(this._letters[i] + j);
                }
              }
            }
          }
        }
      }
      return numbers;
    };

    QedaElement.prototype._pinObj = function(number, name) {
      var l, len, obj, pins, prop, props;
      obj = {
        name: name,
        number: number
      };
      if (this.properties != null) {
        props = ['bidir', 'ground', 'in', 'inverted', 'out', 'power'];
        for (l = 0, len = props.length; l < len; l++) {
          prop = props[l];
          if (this.properties[prop] != null) {
            pins = Array.isArray(this.properties[prop]) ? this.properties[prop] : [this.properties[prop]];
            obj[prop] = pins.indexOf(name) !== -1;
          }
        }
      }
      return obj;
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
