// Generated by CoffeeScript 1.10.0
(function() {
  var QedaSymbol,
    hasProp = {}.hasOwnProperty;

  QedaSymbol = (function() {
    function QedaSymbol(element, part) {
      this.element = element;
      this.part = part;
      this.settings = this.element.library.symbol;
      this.schematic = this.element.schematic;
      this.shapes = [];
      this.attributes = [];
    }

    QedaSymbol.prototype.addAttribute = function(name, attribute) {
      attribute.name = name;
      return this.attributes[name] = this.addShape('attribute', attribute);
    };

    QedaSymbol.prototype.addPin = function(pin) {
      return this.addShape('pin', pin);
    };

    QedaSymbol.prototype.addRectangle = function(rectangle) {
      return this.addShape('rectangle', rectangle);
    };

    QedaSymbol.prototype.addShape = function(kind, shape) {
      var obj, prop;
      obj = {
        kind: kind
      };
      for (prop in shape) {
        if (!hasProp.call(shape, prop)) continue;
        obj[prop] = shape[prop];
      }
      this.shapes.push(obj);
      return obj;
    };

    QedaSymbol.prototype.calculate = function(gridSize) {
      var i, len, ref, shape;
      if (this._calculated == null) {
        this._calculated = false;
      }
      if (this._calculated) {
        return;
      }
      ref = this.shapes;
      for (i = 0, len = ref.length; i < len; i++) {
        shape = ref[i];
        if (shape.x != null) {
          shape.x *= gridSize;
        }
        if (shape.y != null) {
          shape.y *= gridSize;
        }
        if (shape.length != null) {
          shape.length *= gridSize;
        }
        if (shape.width != null) {
          shape.width *= gridSize;
        }
        if (shape.height != null) {
          shape.height *= gridSize;
        }
      }
      return this._calculated = true;
    };

    QedaSymbol.prototype.invertVertical = function() {
      var i, len, ref, results, shape;
      ref = this.shapes;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        shape = ref[i];
        if (shape.y != null) {
          shape.y *= -1;
        }
        if (shape.height != null) {
          results.push(shape.height *= -1);
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    return QedaSymbol;

  })();

  module.exports = QedaSymbol;

}).call(this);
